/*   ¡Bienvenid@ a otro ejercicio en PIXO!

     Este es el -Ejercicio_07- del -Curso PONG-.
     Hoy progamaremos una logica para que la pelota
     apareza en la matrix con mas distancia hacia el jugador 
     que marco el punto, para que su tiempo de reaccion sea mayor.

     ¡Comencemos!
*/


//Librerias
#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>
#include <Adafruit_NeoPixel.h>
#ifndef PSTR                        //Hace feliz a Arduino :)
#define PSTR
#endif
#define PIN 12                      //PIN para controlar la Matriz LED
//Definicion de pines de botones
#define B1 2 //JUGADOR 1
#define B2 3//JUGADOR 2
#define B3 4 //JUGADOR 2
#define B4 5 //JUGADOR 1

//Definicion de la Matriz LED
Adafruit_NeoMatrix matrix = Adafruit_NeoMatrix(8, 8, PIN, NEO_MATRIX_BOTTOM + NEO_MATRIX_RIGHT + NEO_MATRIX_ROWS + NEO_MATRIX_PROGRESSIVE, NEO_GRB + NEO_KHZ800);

//Pelota
//El juego Pong tiene una pelota que se mueve por toda la pantalla. Esta rebota con las paredes y los jugadores.
//Para controlar su movimiento debemos guardar sus coordenadas en X e Y en una variable array entera.
//Iniciaremos esta variable en la ubicacion 3,3. Esto se hace para que la pelota este en la mitad de la pantalla aproximadamente.
int pelota [2] = {3, 4};

//Direccion
//La pelota tendra movimiento, para esto debemos saber hacia donde se esta moviendo. Como tenemos dos coordenadas, tenemos 4 direcciones.
// +X, -X, +Y y -Y.
//Para guardar las direcciones usaremos una variable array entera, los valores podran tomar los valores de +1 y -1. Siendo +1 ir hacia la derecha o abajo en la pantalla y -1 ir hacia la izquiera o arriba.
//Iniciaremos esta variable en la direccion 1,1. Esto se hace para que la pelota salga hacia abajo a la derecha.
int direccion [2] = {1, 1};

//Jugador 1
//Los jugadores son barritas de 3 pixeles de largo. Estos se mueven hacia arriba y abajo, en el eje Y. El jugador 1 esta ubicado en la posicion X == 0, mientras que el jugaor 2 esta en la posicion X == 7.
//Para mover al jugador, se deben presionar los botones. Usaremos el boton 1 para subir al jugador 1 y el 4 para bajarlo.
//Como en la pelota, debemos guardar su posicion. Para eso usaremos una sola variable, para la posicion en Y.

int jugador_1 = 3;

//Jugador 2
//Los jugadores son barritas de 3 pixeles de largo. Estos se mueven hacia arriba y abajo, en el eje Y. El jugador 1 esta ubicado en la posicion X == 0, mientras que el jugaor 2 esta en la posicion X == 7.
//Para mover al jugador, se deben presionar los botones. Usaremos el boton 2 para subir al jugador 1 y el 3 para bajarlo.
//Como en la pelota, debemos guardar su posicion. Para eso usaremos una sola variable, para la posicion en Y.

int jugador_2 = 3;

//Puntaje
//En nuestro PONG, el primer jugador que logre 3 puntos sera el ganador. Para esto debemos guardar los puntajes de ambos jugadores.
//Usaremos una variable entera array. Las iniciaremos en 0. El valor puntajes[0] refiere al jugador 1, mientras el valor puntajes[1] refiere al jugador 2

int puntajes [2] = {0, 0};

//Bandera de punto marcado
//Crearemos una variable booleana que nos ayudara a saber cuando un jugador marco un tanto.

boolean marcaron_punto = false;

//SETUP
void setup() {

  //Para comenzar a programar la Matriz LED debemos iniciarla. Escribe la instruccion para iniciar la Matriz!
  matrix.begin();//<--- AQUI -- Inicia la Matriz LED

  //Ahora que nuestra Matriz LED esta iniciada, debemos configurar el brillo de los leds. Escribe la instruccion para configurar el brillo!
  matrix.setBrightness(20);//<--- AQUI -- Configura el brillo de la Matriz LED

  //Ya configurmos el brillo de los leds.

  matrix.show();
  //Configuracion de los botones como entrada
  pinMode(B1, INPUT_PULLUP);
  pinMode(B2, INPUT_PULLUP);
  pinMode(B3, INPUT_PULLUP);
  pinMode(B4, INPUT_PULLUP);

  //Creamos una semilla de valor random
  randomSeed(analogRead(A0));

}


//LOOP
void loop() {

  //Para que la pelota se mueva debemos dibujarla en el loop, la velocidad del movimiento se determinara por el delay que el loop posea.
  //Comencemos dibujando la pelota en su ubicacion.

  matrix.drawPixel(pelota[0], pelota[1], matrix.Color(255, 255, 255));

  //Codigo J1
  //Luego de dibujar la pelota, dibujaremos el jugador 1. Para esto debemos dibujar el pixel en el que se encuentra, el superior y el inferior.
  matrix.drawPixel(0, jugador_1 - 1, matrix.Color(255, 255, 255));
  matrix.drawPixel(0, jugador_1, matrix.Color(255, 255, 255));
  matrix.drawPixel(0, jugador_1 + 1, matrix.Color(255, 255, 255));

  //A continuacion debemos actualizar la posicion del jugador, dependiendo de los botones que se presionen.

  //Realicemos la lectura de los botones. Guardemos estos datos en una variable entera llamada lectura_j1
  int lectura_j1 = 0;
  if (digitalRead(B1) == HIGH) {
    lectura_j1 = -1;
  }
  else if (digitalRead(B4) == HIGH) {
    lectura_j1 = 1;
  }
  else {
    lectura_j1 = 0;
  }

  //Actualicemos al jugador, contemplando los casos borde.
  //Debemos recordar que el jugador posee dos pixeles mas, ademas de su ubicacion, por lo que el caso borde debe ser entre 1 y 6.

  if (jugador_1 != 1 and lectura_j1 != 1) { //El jugador_1 NO esta en el borde superior y su direccion es hacia arriba.
    jugador_1 += lectura_j1;
  }
  else if (jugador_1 != 6 and lectura_j1 != -1) { //El jugador_1 NO esta en el borde inferior y su direccion es hacia abajo.
    jugador_1 += lectura_j1; //Cambiar ACTUALIZACION_J1 con la actualizacion de la direccion del jugador_1, como se debe cambiar?
  }
  //Si ninguno de los casos anteriores se cumple, significa que estamos en un caso borde, por lo que no actualizamos la posicion del jugador 1.


  //Codigo J2
  //Luego de dibujar el jugador 1, dibujaremos el jugador 2. Para esto debemos dibujar el pixel en el que se encuentra, el superior y el inferior.
  matrix.drawPixel(7, jugador_2 - 1, matrix.Color(255, 255, 255));
  matrix.drawPixel(7, jugador_2, matrix.Color(255, 255, 255));
  matrix.drawPixel(7, jugador_2 + 1, matrix.Color(255, 255, 255));


  //Realicemos la lectura de los botones. Guardemos estos datos en una variable entera llamada lectura_j2
  int lectura_j2 = 0;
  if (digitalRead(B2) == HIGH) {
    lectura_j2 = -1;
  }
  else if (digitalRead(B3) == HIGH) {
    lectura_j2 = 1;
  }
  else {
    lectura_j2 = 0;
  }

  //Actualicemos al jugador, contemplando los casos borde.
  //Debemos recordar que el jugador posee dos pixeles mas, ademas de su ubicacion, por lo que el caso borde debe ser entre 1 y 6.

  if (jugador_2 != 1 and lectura_j2 != 1) { //El jugador_1 NO esta en el borde superior y su direccion es hacia arriba.
    jugador_2 += lectura_j2;
  }
  else if (jugador_2 != 6 and lectura_j2 != -1) { //El jugador_1 NO esta en el borde inferior y su direccion es hacia abajo.
    jugador_2 += lectura_j2; //Cambiar ACTUALIZACION_J1 con la actualizacion de la direccion del jugador_1, como se debe cambiar?
  }
  //Si ninguno de los casos anteriores se cumple, significa que estamos en un caso borde, por lo que no actualizamos la posicion del jugador 1.


  //Actualizacion de posicion de la pelota.
  //Modificaremos los casos borde de la pelota, actualizaremos la posicion de esta y el puntaje de los jugadores si logramos hacer un tanto al otro jugador.
  if (pelota[0] == 1 and direccion[0] == -1 and (abs(pelota[1] - jugador_1)) <= 1) {
    direccion[0] = 1;
  }
  else if (pelota[0] == 6 and direccion[0] == 1 and (abs(pelota[1] - jugador_2)) <= 1) {
    direccion[0] = -1;
  }

  //CASOS BORDE QUE SON TANTOS
  if (pelota[0] == 0 and direccion[0] == -1) { //La pelota esta en el borde en X izquierdo y su direccion es hacia la izquierda. Nos encontramos en un caso borde.
    direccion[0] = 1;
    //Reiniciamos la posicion de la pelota de modo que la distancia al jugador sea mayor
    pelota[0] = 1; 
    pelota[1] = 4;
    //Marcamos un tanto al jugador 2
    puntajes[1] += 1;
    //Cambiamos el valor de marcaron_punto a true
    marcaron_punto = true;
  }
  else if (pelota[0] == 7 and direccion[0] == 1) { //La pelota esta en el borde en X derecho y su direccion es hacia la derecha. Nos encontramos en un caso borde.
    direccion[0] = -1;
    //Reiniciamos la posicion de la pelota de modo que la distancia al jugador sea mayor
    pelota[0] = 6;
    pelota[1] = 4;
    //Marcamos un tanto al jugador 1
    puntajes[0] += 1;
    //Cambiamos el valor de marcaron_punto a true
    marcaron_punto = true;
  }
  pelota[0] += direccion[0]; //Actualizamos la posicion de la pelota en X.



  if (pelota[1] == 0 and direccion[1] == -1) { //La pelota esta en el borde en Y superior y su direccion es hacia la arriba. Nos encontramos en un caso borde.
    direccion[1] = 1;
  }
  else if (pelota[1] == 7 and direccion[1] == 1) { //La pelota esta en el borde en X inferior y su direccion es hacia la abajo. Nos encontramos en un caso borde.
    direccion[1] = -1;
  }
  pelota[1] += direccion[1]; //Actualizamos la posicion de la pelota en X.


  matrix.show();
  delay(200);
  matrix.clear();
  delay(200);

  //Si un punto fue marcado, entonces mostramos el puntaje en pantalla
  //Aqui sumaremos la logica de finalizacion del juego.
  //Nos preguntaremos si el puntaje de los jugadores es igual a 3. Si es asi, entonces mostramos quien gano y reiniciamos los puntajes.
  if (marcaron_punto == true) {
    //Escibiremos el puntaje.
    for (int i = 4; i > -15; i--) {
      //Colocar el cursor en la posición del pixel i, 1
      matrix.setCursor(i, 1); //Se para en la posición del pixel i, 1

      //Para imprimir un caracter utilizamos el comando --> matrix.print(VARIABLE);
      matrix.print(String(puntajes[0]) + "-" + String(puntajes[1])); //Valor final obtenido

      //Una vez que programada a la Matriz LED, le debemos dar la orden para mostrar que le programamos.
      matrix.show(); //Mostrar los cambios en la Matriz LED
      delay(200);
      matrix.clear(); //Limpia la matriz, apaga todos los pixeles.

    }
    //Reiniciamos la variable bandera
    marcaron_punto = false;

    //Chequeo de ganador
    if (puntajes[0] == 3) { //Ganador jugador_1
      for (int i = 0; i < 8; i++) { //Pintamos el lado del jugador_1 con verde, y el lado del jugador_2 con rojo
        matrix.drawPixel(0, i, matrix.Color(0, 255, 0));
        matrix.drawPixel(7, i, matrix.Color(255, 0, 0));
      }
      matrix.show();
      delay(2000);
      matrix.clear();
      //Reiniciamos los valores de los puntajes
      puntajes[0] = 0;
      puntajes[1] = 0;
    }
    else if (puntajes[1] == 3) { //Ganador jugador_2
      for (int i = 0; i < 8; i++) { //Pintamos el lado del jugador_2 con verde, y el lado del jugador_1 con rojo
        matrix.drawPixel(7, i, matrix.Color(0, 255, 0));
        matrix.drawPixel(0, i, matrix.Color(255, 0, 0));
      }
      matrix.show();
      delay(2000);
      matrix.clear();
      //Reiniciamos los valores de los puntajes
      puntajes[0] = 0;
      puntajes[1] = 0;
    }
  }

  //Si llegaste hasta aqui significa que termino el tutorial del ejercicio 7, ahora completa el ejercicio y envia el codigo a tu kit PIXO.


}
